//Copyright (c) Victor Hurdugaci
//http://victorhurdugaci.com
//This code is licensed under the Non-Profit Open Software License version 3.0
//Full license text: http://www.opensource.org/licenses/NOSL3.0.html

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using System.Windows;
using System.Windows.Interop;

namespace ImageVisualizer.GUI
{
    class WindowHelpers
    {
        #region Constants

        private static readonly int GWL_STYLE = -16;

        private static readonly int WS_MINIMIZEBOX = 0x0020000;


        #endregion

        #region Methods

        public static void DisableMinimizeBox(Window wnd)
        {
            WindowInteropHelper windowInterop = new WindowInteropHelper(wnd);
            IntPtr hwnd = windowInterop.Handle;

            int windowLong = GetWindowLong(hwnd, GWL_STYLE);
            
            windowLong = windowLong ^ WS_MINIMIZEBOX;
            SetWindowLong(hwnd, GWL_STYLE, windowLong);
        }

        [DllImport("user32.dll")]
        private static extern int SetWindowLong(IntPtr hWnd, int nIndex, int dwNewLong);

        [DllImport("user32.dll")]
        private static extern int GetWindowLong(IntPtr hWnd, int nIndex);

        #endregion
    }
}
