//Copyright (c) Victor Hurdugaci
//http://victorhurdugaci.com
//This code is licensed under the Non-Profit Open Software License version 3.0
//Full license text: http://www.opensource.org/licenses/NOSL3.0.html

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Media.Imaging;
using System.Drawing;
using System.Windows;
using System.Runtime.InteropServices;
using System.Windows.Interop;

namespace ImageVisualizer
{
    static class ImageConverters
    {
        #region Methods

        public static BitmapSource ConvertBitmapToBitmapSource(Bitmap sourceBitmap)
        {
            BitmapSource bitmapSource = null;

            IntPtr bitmapPointer = sourceBitmap.GetHbitmap();
            
            try
            {
                bitmapSource = Imaging.CreateBitmapSourceFromHBitmap(bitmapPointer,
                   IntPtr.Zero, Int32Rect.Empty,
                   System.Windows.Media.Imaging.BitmapSizeOptions.FromEmptyOptions());
            }
            finally
            {
                DeleteObject(bitmapPointer);
            }

            return bitmapSource;
        }

        [DllImport("gdi32")]
        private static extern int DeleteObject(IntPtr o);

        #endregion
    }
}
