//Copyright (c) Victor Hurdugaci
//http://victorhurdugaci.com
//This code is licensed under the Non-Profit Open Software License version 3.0
//Full license text: http://www.opensource.org/licenses/NOSL3.0.html

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.VisualStudio.DebuggerVisualizers;
using System.Diagnostics;
using System.Drawing;
using ImageVisualizer.GUI;

[assembly: DebuggerVisualizer(typeof(ImageVisualizer.Visualizer), typeof(VisualizerObjectSource),
    Description = "View as image", Target = typeof(Image))]

namespace ImageVisualizer
{
    /// <summary>
    /// The main Visualizer class. Here starts everything
    /// </summary>
    public class Visualizer : DialogDebuggerVisualizer
    {
        #region Fields

        ImageWindow _gui;

        #endregion

        #region Methods

        protected override void Show(IDialogVisualizerService windowService, IVisualizerObjectProvider objectProvider)
        {
            object sourceGraphics = objectProvider.GetObject();

            CreateGUI(sourceGraphics);

            if (_gui!=null)
                _gui.ShowDialog();
        }

        private void CreateGUI(object sourceGraphics)
        {
            if (sourceGraphics is Image)
            {
                _gui = new ImageWindow((Image)sourceGraphics);
            }
        }

        #endregion
    }
}
